#ifndef _WEBFRONTEND_h
#define _WEBFRONTEND_h

#include "Arduino.h"
#include "ESP8266WiFi.h"
#include "WiFiClient.h"
#include "ESP8266WebServer.h"
#include "StateManager.h"
#include "Logger.h"

class WebFrontend {
 public:
   WebFrontend(int port);
   void Handle();
   void Begin(StateManager *stateManager, Logger *logger);
   ESP8266WebServer *WebServer();
   typedef void CommandCallbackType(String);
   void SetCommandCallback(CommandCallbackType callback);
   void SetPassword(String password);

private:
  int m_port;
  ESP8266WebServer m_webserver;
  Logger *m_logger;
  StateManager *m_stateManager;
  CommandCallbackType *m_CommandCallback;
  String m_password;
  String GetNavigation();
  String GetTop();
  String GetBottom();
  String GetRedirectToRoot(String message = "");
  bool IsAuthentified();
};

#endif

